﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.OleDb;

namespace HladanieHesiel
{
    class Excel
    {
        OleDbConnection spojenie;
        OleDbCommand prikaz;
        OleDbDataAdapter adapter;
        DataSet datovySubor;
        DataTable tabulka;

        public DataTable Tabulka { get { return tabulka; } set { tabulka = value; } }

        public Excel()
        {
            datovySubor = new DataSet();
            tabulka = new DataTable();
            spojenie = new OleDbConnection();
            prikaz = new OleDbCommand();
            adapter = new OleDbDataAdapter();
        }

        public void OtvoritSubor(string nazovSuboru)
        {
            StringBuilder pripojovaciRetazec = new StringBuilder();
            string chybovaSprava = "Súbor programu Excel nemá správnu štruktúru!";
            datovySubor.Clear();
            pripojovaciRetazec.Append(@"Provider=Microsoft.ACE.OLEDB.12.0;Data Source=");
            pripojovaciRetazec.Append(nazovSuboru);
            pripojovaciRetazec.Append(@";Extended Properties=""Excel 12.0;HDR=NO;""");

            try
            {
                spojenie.ConnectionString = pripojovaciRetazec.ToString();
                if (spojenie.State == ConnectionState.Closed)
                    spojenie.Open();

                prikaz.Connection = spojenie;
                adapter.SelectCommand = prikaz;
                VykonajSqlPrikaz("SELECT * FROM [Sheet1$A1:C1]");
                if (tabulka.Rows[0][0].ToString() != "Meno")
                    throw new Exception(chybovaSprava);
                if (tabulka.Rows[0][1].ToString() != "Hash")
                    throw new Exception(chybovaSprava);
                if (tabulka.Rows[0][2].ToString() != "Heslo")
                    throw new Exception(chybovaSprava);

                VykonajSqlPrikaz("SELECT * FROM [Sheet1$A2:B65536]");
            }
            catch (Exception)
            {
                UkonciSpojenie();
                throw;
            }
        }

        public void UlozitSubor(List<string> zoznam)
        {
            try
            {
                for (int i = 0; i < zoznam.Count; i++)
                    VykonajSqlPrikaz("UPDATE [Sheet1$C" + (i + 2).ToString() + ":C" + (i + 2).ToString() + "] SET F1 = '" + zoznam[i] + "'");
                
                UkonciSpojenie();
            }
            catch (Exception)
            {
                UkonciSpojenie();
                throw;
            }
        }

        private void VykonajSqlPrikaz(string prikazSQL)
        {
            datovySubor.Clear();
            prikaz.CommandText = prikazSQL;
            adapter.Fill(datovySubor, "SOURCE");
            tabulka = datovySubor.Tables["SOURCE"];
        }

        public void UkonciSpojenie()
        {
            adapter.Dispose();
            prikaz.Dispose();
            spojenie.Close();
            spojenie.Dispose();
        }
    }
}