﻿using System;
using System.Text;
using System.Security.Cryptography;

namespace HladanieHesiel
{
    class MD5 : IDisposable
    {
        MD5CryptoServiceProvider md5CryptoServiceProvider;
        Byte[] bajtovePole;
        UTF8Encoding koder;
        string meno;
        string heslo;
        string hash;
        string dlzkaHesla;
        bool disposed;

        public string Meno { get { return meno; } set { meno = value; } }
        public string Hash { get { return hash; } set { hash = value; } }
        public string Heslo { get { return heslo; } set { heslo = value; } }
        public string DlzkaHesla { get { return dlzkaHesla; } set { dlzkaHesla = value; } }
        
        public MD5(string meno, string hash)
        {
            md5CryptoServiceProvider = new MD5CryptoServiceProvider();
            koder = new UTF8Encoding();
            this.meno = meno;
            this.hash = hash;
            this.heslo = String.Empty;
            disposed = false;
        }

        #region Inplementácia návrhového vzoru Dispose
        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }
        
        protected virtual void Dispose(bool disposing)
        {
            if (!disposed)
            {
                if (disposing)
                    md5CryptoServiceProvider.Dispose();
                
                md5CryptoServiceProvider = null;
                if (bajtovePole!= null)
                    Array.Clear(bajtovePole, 0, bajtovePole.Length);

                bajtovePole = null;
                koder = null;
                meno = null;
                heslo = null;
                hash = null;
                dlzkaHesla = null;
                disposed = true;
            }
        }
        
        ~MD5()
        {
            Dispose(false);
        }
        #endregion

        public void NajdiHeslo()
        {
            string kandidatNaHeslo;
            switch (dlzkaHesla)
            {
                case "6":
                    for (int i = 0; i < 1000000; i++)
                    {
                        kandidatNaHeslo = i.ToString("D6");
                        if (Zasifruj(this.meno, kandidatNaHeslo) == this.hash)
                        {
                            this.heslo = kandidatNaHeslo;
                            break;
                        }
                    }
                    break;
                case "8":
                    for (int i = 0; i < 100000000; i++)
                    {
                        kandidatNaHeslo = i.ToString("D8");
                        if (Zasifruj(this.meno, kandidatNaHeslo) == this.hash)
                        {
                            this.heslo = kandidatNaHeslo;
                            break;
                        }
                    }
                    break;
            }
        }

        private string Zasifruj(string meno, string heslo)
        {
            bajtovePole = koder.GetBytes(heslo + meno);
            bajtovePole = md5CryptoServiceProvider.ComputeHash(bajtovePole);
            return Convert.ToBase64String(bajtovePole);
        }
    }
}